﻿using System.Diagnostics;
using NAudio;
using NAudio.Wave;
// using ManagedBass;
// using ManagedBass.Mix;

namespace Elementary.Audio;

public class AudioConverter : IAudioConverter
{
    public readonly WaveFormat WaveFormat = new(48000, 16, 2);

    public WaveFormatConversionStream CreateStreamFromFilePath(string path, float volume = 1.0f)
        => new(WaveFormat, new VolumeAdjustedWaveStream(new MediaFoundationReader(path), volume));

    /// <summary>
    /// Return PCM stream from any codec of audio stream
    /// </summary>
    /// <param name="stream"></param>
    /// <returns></returns>
    public WaveFormatConversionStream CreateStreamFromStream(Stream stream)
    {
        return new(WaveFormat, new StreamMediaFoundationReader(stream));
    }

    /// <summary>
    ///  Return PCM stream from any codec of audio stream
    /// </summary>
    /// <param name="stream"></param>
    /// <param name="volume"></param>
    /// <returns></returns>
    public WaveFormatConversionStream CreateStreamFromStream(Stream stream, float volume = 1.0f)
    {
        return new(WaveFormat, new VolumeAdjustedWaveStream(new StreamMediaFoundationReader(stream), volume));
    }
}