﻿using System.Diagnostics;
using System.Text;
using NLog;

namespace Elementary.Audio;

public class Ytdlp
{
    private readonly ILogger _logger;

    public Ytdlp()
    {
        _logger = LogManager.GetCurrentClassLogger();
    }

    public async Task<Stream> GetStream(string url)
    {
        var process = new Process
        {
            StartInfo =
            {
                FileName = "yt-dlp",
                Arguments = $"-f bestaudio -o - {url}",
                RedirectStandardOutput = true,
                RedirectStandardError = true,
                UseShellExecute = false,
                CreateNoWindow = true
            },
            EnableRaisingEvents = true
        };

        var stream = new MemoryStream();
        process.Start();
        process.StandardOutput.BaseStream.CopyTo(stream);
        process.WaitForExit();
        stream.Position = 0;
        return stream;
    }
}