﻿using Discord.WebSocket;
using Elementary.Audio;

namespace Elementary.Message;

public class MessageHandler
{
    // private IAudioClient _audioClient;
    private PlaybackQueue _playbackQueue;

    public MessageHandler(PlaybackQueue playbackQueue)
    {
        _playbackQueue = playbackQueue;
    }


    public async Task HandleMessage(SocketMessage message)
    {
        // if contains mention, add mentioned user name to lines and replace <id>
        List<String> lines = new();

        if (message.MentionedUsers.Count > 0)
        {
            foreach (var mentionedUser in message.MentionedUsers)
            {
                message.Content.Replace(mentionedUser.Mention, $"@{mentionedUser.GlobalName}").Split('\n').ToList()
                    .ForEach(lines.Add);
            }
        }
        else
        {
            if (message.Content.Contains("```"))
            {
                lines = new List<string> {"コードブロック"};
            }
            else
            {
                message.Content.Split('\n').ToList().ForEach(lines.Add);
            }
        }


        foreach (var line in lines)
        {
            await _playbackQueue.Enqueue(new PlaybackJob()
            {
                Type = JobType.Text,
                Text = line
            });
        }
    }
}